---
title: Upload a legacy schema
---

[Skip to content](#_top)

[API Reference](https://developers.cloudflare.com/api/python)

[API Gateway](https://developers.cloudflare.com/api/python/resources/api_gateway)

[User Schemas](https://developers.cloudflare.com/api/python/resources/api_gateway/subresources/user_schemas)

Copy Markdown

Open in **Claude**Open in **ChatGPT**Open in **Cursor**

---

**Copy Markdown****View as Markdown**

# Upload a legacy schema

Deprecated: Use \[Schema Validation API](https://developers.cloudflare.com/api/resources/schema\_validation/) instead.

api\_gateway.user\_schemas.create(UserSchemaCreateParams\*\*kwargs) -> [UserSchemaCreateResponse](<https://developers.cloudflare.com/api/python/resources/api_gateway#(resource)%20api_gateway.user_schemas%20%3E%20(model)%20user_schema_create_response%20%3E%20(schema)>)

POST/zones/{zone\_id}/api\_gateway/user\_schemas

Uploads an OpenAPI schema that defines expected request formats for API endpoints. Deprecated; use `/zones/{zone_id}/schema_validation/schemas` instead.

##### Security

<details>

<summary>API Token</summary>



The preferred authorization scheme for interacting with the Cloudflare API. <a href="https://developers.cloudflare.com/fundamentals/api/get-started/create-token/">Create a token</a>.

**Example:**<code>Authorization: Bearer Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY</code>

</details>

<details>

<summary>API Email + API Key</summary>



The previous authorization scheme for interacting with the Cloudflare API, used in conjunction with a Global API key.

**Example:**<code>X-Auth-Email: user@example.com</code>

The previous authorization scheme for interacting with the Cloudflare API. When possible, use API tokens instead of Global API keys.

**Example:**<code>X-Auth-Key: 144c9defac04969c7bfad8efaa8ea194</code>

</details>

##### Accepted Permissions (at least one required)

`Account API Gateway``Domain API Gateway`

##### ParametersExpand Collapse

zone\_id: str

Identifier.

maxLength32

[Link to this property](<#(resource)%20api_gateway.user_schemas%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20zone_id%20%3E%20(schema)>)

file: [FileTypes](<https://developers.cloudflare.com/api/python/resources/api_gateway/subresources/user_schemas/methods/create#(resource)%20api_gateway.user_schemas%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20file%20%3E%20(schema)>)

Schema file bytes

[Link to this property](<#(resource)%20api_gateway.user_schemas%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20file%20%3E%20(schema)>)

kind: Literal\["openapi\_v3"]

Kind of schema

[Link to this property](<#(resource)%20api_gateway.user_schemas%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20kind%20%3E%20(schema)>)

name: Optional\[str]

Name of the schema

[Link to this property](<#(resource)%20api_gateway.user_schemas%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20name%20%3E%20(schema)>)

<details>

<summary>

validation\_enabled: Optional\[Literal\["true", "false"]]

Flag whether schema is enabled for validation.

</summary>

One of the following:

"true"

<a href="#(resource)%20api_gateway.user_schemas%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20validation_enabled%20%3E%20(schema)%20%3E%20(member)%200">Link to this property</a>

"false"

<a href="#(resource)%20api_gateway.user_schemas%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20validation_enabled%20%3E%20(schema)%20%3E%20(member)%201">Link to this property</a>

</details>

[Link to this property](<#(resource)%20api_gateway.user_schemas%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20validation_enabled%20%3E%20(schema)>)

##### ReturnsExpand Collapse

<details>

<summary>

class UserSchemaCreateResponse: …

</summary>

<details>

<summary>

schema: <a href="https://developers.cloudflare.com/api/python/resources/api_gateway#(resource)%20api_gateway.user_schemas%20%3E%20(model)%20old_public_schema%20%3E%20(schema)">OldPublicSchema</a>

</summary>

created\_at: datetime

formatdate-time

<a href="#(resource)%20api_gateway.user_schemas%20%3E%20(model)%20user_schema_create_response%20%3E%20(schema)%20%3E%20(property)%20schema%20%2B%20(resource)%20api_gateway.user_schemas%20%3E%20(model)%20old_public_schema%20%3E%20(schema)%20%3E%20(property)%20created_at">Link to this property</a>

kind: Literal\["openapi\_v3"]

Kind of schema

<a href="#(resource)%20api_gateway.user_schemas%20%3E%20(model)%20user_schema_create_response%20%3E%20(schema)%20%3E%20(property)%20schema%20%2B%20(resource)%20api_gateway.user_schemas%20%3E%20(model)%20old_public_schema%20%3E%20(schema)%20%3E%20(property)%20kind">Link to this property</a>

name: str

Name of the schema

<a href="#(resource)%20api_gateway.user_schemas%20%3E%20(model)%20user_schema_create_response%20%3E%20(schema)%20%3E%20(property)%20schema%20%2B%20(resource)%20api_gateway.user_schemas%20%3E%20(model)%20old_public_schema%20%3E%20(schema)%20%3E%20(property)%20name">Link to this property</a>

schema\_id: str

UUID.

maxLength36

minLength36

<a href="#(resource)%20api_gateway.user_schemas%20%3E%20(model)%20user_schema_create_response%20%3E%20(schema)%20%3E%20(property)%20schema%20%2B%20(resource)%20api_gateway.user_schemas%20%3E%20(model)%20old_public_schema%20%3E%20(schema)%20%3E%20(property)%20schema_id">Link to this property</a>

source: Optional\[str]

Source of the schema

<a href="#(resource)%20api_gateway.user_schemas%20%3E%20(model)%20user_schema_create_response%20%3E%20(schema)%20%3E%20(property)%20schema%20%2B%20(resource)%20api_gateway.user_schemas%20%3E%20(model)%20old_public_schema%20%3E%20(schema)%20%3E%20(property)%20source">Link to this property</a>

validation\_enabled: Optional\[bool]

Flag whether schema is enabled for validation.

<a href="#(resource)%20api_gateway.user_schemas%20%3E%20(model)%20user_schema_create_response%20%3E%20(schema)%20%3E%20(property)%20schema%20%2B%20(resource)%20api_gateway.user_schemas%20%3E%20(model)%20old_public_schema%20%3E%20(schema)%20%3E%20(property)%20validation_enabled">Link to this property</a>

</details>

<a href="#(resource)%20api_gateway.user_schemas%20%3E%20(model)%20user_schema_create_response%20%3E%20(schema)%20%3E%20(property)%20schema">Link to this property</a>

<details>

<summary>

upload\_details: Optional\[UploadDetails]

</summary>

<details>

<summary>

warnings: Optional\[List\[UploadDetailsWarning]]

Diagnostic warning events that occurred during processing. These events are non-critical errors found within the schema.

</summary>

code: int

Code that identifies the event that occurred.

<a href="#(resource)%20api_gateway.user_schemas%20%3E%20(model)%20user_schema_create_response%20%3E%20(schema)%20%3E%20(property)%20upload_details%20%3E%20(property)%20warnings%20%3E%20(items)%20%3E%20(property)%20code">Link to this property</a>

locations: Optional\[List\[str]]

JSONPath location(s) in the schema where these events were encountered. See <a href="https://goessner.net/articles/JsonPath/">https://goessner.net/articles/JsonPath/</a> for JSONPath specification.

<a href="#(resource)%20api_gateway.user_schemas%20%3E%20(model)%20user_schema_create_response%20%3E%20(schema)%20%3E%20(property)%20upload_details%20%3E%20(property)%20warnings%20%3E%20(items)%20%3E%20(property)%20locations">Link to this property</a>

message: Optional\[str]

Diagnostic message that describes the event.

<a href="#(resource)%20api_gateway.user_schemas%20%3E%20(model)%20user_schema_create_response%20%3E%20(schema)%20%3E%20(property)%20upload_details%20%3E%20(property)%20warnings%20%3E%20(items)%20%3E%20(property)%20message">Link to this property</a>

</details>

<a href="#(resource)%20api_gateway.user_schemas%20%3E%20(model)%20user_schema_create_response%20%3E%20(schema)%20%3E%20(property)%20upload_details%20%3E%20(property)%20warnings">Link to this property</a>

</details>

<a href="#(resource)%20api_gateway.user_schemas%20%3E%20(model)%20user_schema_create_response%20%3E%20(schema)%20%3E%20(property)%20upload_details">Link to this property</a>

</details>

[Link to this property](<#(resource)%20api_gateway.user_schemas%20%3E%20(model)%20user_schema_create_response%20%3E%20(schema)>)

### Upload a legacy schema

Python

HTTPTypeScriptPythonGoTerraform

```
import os
from cloudflare import Cloudflare

client = Cloudflare(
    api_token=os.environ.get("CLOUDFLARE_API_TOKEN"),  # This is the default and can be omitted
)
user_schema = client.api_gateway.user_schemas.create(
    zone_id="023e105f4ecef8ad9ca31a8372d0c353",
    file=b"Example data",
    kind="openapi_v3",
)
print(user_schema.schema)
```

200 example

```
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "result": {
    "schema": {
      "created_at": "2014-01-01T05:20:00.12345Z",
      "kind": "openapi_v3",
      "name": "petstore schema",
      "schema_id": "f174e90a-fafe-4643-bbbc-4a0ed4fc8415",
      "source": "<schema file bytes>",
      "validation_enabled": true
    },
    "upload_details": {
      "warnings": [
        {
          "code": 28,
          "locations": [
            ".paths[\"/user/{username}\"].put"
          ],
          "message": "unsupported media type: application/octet-stream"
        }
      ]
    }
  },
  "success": true
}
```

##### Returns Examples

200 example

```
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "result": {
    "schema": {
      "created_at": "2014-01-01T05:20:00.12345Z",
      "kind": "openapi_v3",
      "name": "petstore schema",
      "schema_id": "f174e90a-fafe-4643-bbbc-4a0ed4fc8415",
      "source": "<schema file bytes>",
      "validation_enabled": true
    },
    "upload_details": {
      "warnings": [
        {
          "code": 28,
          "locations": [
            ".paths[\"/user/{username}\"].put"
          ],
          "message": "unsupported media type: application/octet-stream"
        }
      ]
    }
  },
  "success": true
}
```